# SwaggerClient-php
No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 3.0.x
- Build package: io.swagger.codegen.languages.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: ApiKeyAuth
$config = Wodby\Api\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Wodby\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Wodby\Api\Api\ApplicationApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$data = new \Wodby\Api\Model\RequestAppCreate(); // \Wodby\Api\Model\RequestAppCreate | 

try {
    $result = $apiInstance->createApp($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationApi->createApp: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.wodby.com/api/v3*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApplicationApi* | [**createApp**](docs/Api/ApplicationApi.md#createapp) | **POST** /apps | 
*ApplicationApi* | [**deleteApp**](docs/Api/ApplicationApi.md#deleteapp) | **DELETE** /apps/{id} | 
*ApplicationApi* | [**getApp**](docs/Api/ApplicationApi.md#getapp) | **GET** /apps/{id} | 
*ApplicationApi* | [**getApps**](docs/Api/ApplicationApi.md#getapps) | **GET** /apps | 
*BackupApi* | [**getBackup**](docs/Api/BackupApi.md#getbackup) | **GET** /backups/{id} | 
*BackupApi* | [**getBackups**](docs/Api/BackupApi.md#getbackups) | **GET** /backups | 
*DomainApi* | [**getDomain**](docs/Api/DomainApi.md#getdomain) | **GET** /domains/{id} | 
*DomainApi* | [**getDomains**](docs/Api/DomainApi.md#getdomains) | **GET** /domains | 
*GitRepositoryApi* | [**getGitRepo**](docs/Api/GitRepositoryApi.md#getgitrepo) | **GET** /git-repo/{id} | 
*GitRepositoryApi* | [**getGitRepos**](docs/Api/GitRepositoryApi.md#getgitrepos) | **GET** /git-repo | 
*InstanceApi* | [**createInstance**](docs/Api/InstanceApi.md#createinstance) | **POST** /instances | 
*InstanceApi* | [**deleteInstance**](docs/Api/InstanceApi.md#deleteinstance) | **DELETE** /instances/{id} | 
*InstanceApi* | [**deployInstance**](docs/Api/InstanceApi.md#deployinstance) | **POST** /instances/{id}/deploy | 
*InstanceApi* | [**deployInstanceCodebase**](docs/Api/InstanceApi.md#deployinstancecodebase) | **POST** /instances/{id}/deploy-codebase | 
*InstanceApi* | [**getInstance**](docs/Api/InstanceApi.md#getinstance) | **GET** /instances/{id} | 
*InstanceApi* | [**getInstances**](docs/Api/InstanceApi.md#getinstances) | **GET** /instances | 
*OrganizationApi* | [**getOrg**](docs/Api/OrganizationApi.md#getorg) | **GET** /orgs/{id} | 
*OrganizationApi* | [**getOrgs**](docs/Api/OrganizationApi.md#getorgs) | **GET** /orgs | 
*ServerApi* | [**getServer**](docs/Api/ServerApi.md#getserver) | **GET** /servers/{id} | 
*ServerApi* | [**getServers**](docs/Api/ServerApi.md#getservers) | **GET** /servers | 
*StackApi* | [**getStack**](docs/Api/StackApi.md#getstack) | **GET** /stacks/{id} | 
*StackApi* | [**getStacks**](docs/Api/StackApi.md#getstacks) | **GET** /stacks | 
*TaskApi* | [**getTask**](docs/Api/TaskApi.md#gettask) | **GET** /tasks/{id} | 
*TaskApi* | [**getTasks**](docs/Api/TaskApi.md#gettasks) | **GET** /tasks | 
*UserApi* | [**getAuthenticatedUser**](docs/Api/UserApi.md#getauthenticateduser) | **GET** /user | 


## Documentation For Models

 - [App](docs/Model/App.md)
 - [Backup](docs/Model/Backup.md)
 - [Domain](docs/Model/Domain.md)
 - [GitRepo](docs/Model/GitRepo.md)
 - [Instance](docs/Model/Instance.md)
 - [InstanceType](docs/Model/InstanceType.md)
 - [Org](docs/Model/Org.md)
 - [RequestAppCreate](docs/Model/RequestAppCreate.md)
 - [RequestAppCreateGit](docs/Model/RequestAppCreateGit.md)
 - [RequestAppCreateServices](docs/Model/RequestAppCreateServices.md)
 - [RequestInstanceCreate](docs/Model/RequestInstanceCreate.md)
 - [RequestInstanceCreateGit](docs/Model/RequestInstanceCreateGit.md)
 - [RequestInstanceDeploy](docs/Model/RequestInstanceDeploy.md)
 - [RequestInstanceDeployCodebase](docs/Model/RequestInstanceDeployCodebase.md)
 - [ResponseTask](docs/Model/ResponseTask.md)
 - [ResponseTaskApp](docs/Model/ResponseTaskApp.md)
 - [ResponseTaskInstance](docs/Model/ResponseTaskInstance.md)
 - [Server](docs/Model/Server.md)
 - [Stack](docs/Model/Stack.md)
 - [StackService](docs/Model/StackService.md)
 - [Task](docs/Model/Task.md)
 - [User](docs/Model/User.md)
 - [Uuid](docs/Model/Uuid.md)


## Documentation For Authorization


## ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-KEY
- **Location**: HTTP header


## Author




